<template lang="pug">
.meetingsSection
  ScheduleZoomSenseDialog(
    v-model="addNew",
    :callAlreadyScheduled="callAlreadyScheduled"
  )

  .text-center.q-my-md
    q-btn(@click="addNew = true", rounded, color="primary", size="lg") Add ZoomSense to a Meeting

  .text-h4.text-center.q-my-xl Your Scheduled ZoomSense Meetings

  .row.justify-center
    .col-12.col-md-4.col-lg-3.col-xl-2
      .q-pa-md
        q-input.q-my-md(
          placeholder="Search...",
          outlined,
          rounded,
          v-model="filter.search",
          clearable
        )
        q-date.full-width(
          flat,
          minimal,
          v-model="filter.currentDate",
          today-btn,
          :events="events",
          clearable
        )
        q-toggle(v-model="filter.inFuture", label="Show Upcoming Meetings")

    .col-12.col-md.col-lg-5.q-pl-lg
      div(v-if="firebaseloading")
        .row.justify-center.full-height.full-width.text-center.items-center
          div(style="margin-top: 5em")
            p.text-body1 Getting Your Schedule...
            q-spinner-dots(color="primary", size="xl")

      div(v-if="!firebaseloading")
        div(v-if="scheduledCallsThatMeetFilterCriteriaAsList.length")
          q-timeline(color="grey-5")
            q-timeline-entry(
              :subtitle="getDay(index)",
              v-for="(calls, index) in groupedMeeting",
              :key="index"
            )
              ScheduledCall.q-mb-md(
                v-for="call in calls",
                :key="call.id",
                :callKey="getCallKey(call)",
                :call="call"
              )

        .row.justify-center.full-height.full-width.text-center.items-center(
          v-else,
          style="color: #ccc; text-align: center; margin: 2em"
        )
          div(style="margin-top: 3em")
            q-icon(name="insert_invitation", style="font-size: 10em")
            p.text-h6 Schedule a Zoom meeting to get started.
</template>

<script>
import { db } from "../db";
import ScheduledCall from "./ScheduledCall.vue";
import moment from "moment-timezone";
import { groupBy, map, toArray } from "lodash";
import ErrorHandler from "../mixins/ErrorHandler";
import ScheduleZoomSenseDialog from "./ScheduleZoomSenseDialog.vue";

const meetings = db.ref("meetings");

export default {
  name: "Meetings",
  props: ["user"],
  mixins: [ErrorHandler],
  data() {
    return {
      scheduledZoomMeetings: [],
      firebasemeetings: {},
      zoomloading: true,
      firebaseloading: true,
      tab: "scheduled",
      backdate: "2021-02-05T00:00:00.000Z",
      addNew: false,
      manualadd: false,
      isRequestingManual: false,
      filter: {
        search: "",
        currentDate: "",
        newSearch: "",
        inFuture: true,
      },
    };
  },
  mounted() {
    const anonymous = this.$cookies.get("anonymous");
    if (!anonymous) {
      this.$rtdbBind("firebasemeetings", meetings.child(this.user.uid)).then(
        () => {
          this.firebaseloading = false;
        },
      );
    } else {
      const vueInstance = this;
      const hostuid = anonymous.hostuid;
      const meetingid = anonymous.meetingid;

      db.ref(`meetings/${hostuid}/${meetingid}`).once(
        "value",
        function (snapshot) {
          vueInstance.firebasemeetings[snapshot.key] = snapshot.val();
          vueInstance.firebaseloading = false;
          vueInstance.zoomloading = false;
        },
      );
    }
  },
  methods: {
    getDay(tt) {
      return moment(tt).format("ddd D MMM YYYY");
    },
    getCallKey(call) {
      return call.startTime < this.backdate
        ? call.id
        : `${call.id}_${
            // ZoomSense meetings have startTime
            // zoom meetings have start_time, but not quite in ISO
            (call.startTime || new Date(call.start_time).toISOString())
              .replaceAll("-", "")
              .replaceAll(":", "")
              .split(".")[0]
          }`;
    },
    hasMatch(meeting) {
      //find other meetings and compare titles:
      return this.notRequestedSearch.filter(m => {
        return m.topic == meeting.topic;
      });
    },
    // Return whether a given call has already been scheduled
    // as a ZoomSense call
    callAlreadyScheduled(call) {
      return this.firebasemeetings[this.getCallKey(call)] !== undefined;
    },
  },
  computed: {
    events() {
      return toArray(
        map(this.firebasemeetings, function (f) {
          let split = f.startTime.split("-");
          return `${split[0]}/${split[1]}/${split[2].split("T")[0]}`;
        }),
      );
    },
    scheduledCallsThatMeetFilterCriteriaAsList() {
      let output = [];
      Object.values(this.firebasemeetings)
        .filter(m => {
          return m.topic
            .toLowerCase()
            .includes(
              this.filter.search == null
                ? ""
                : this.filter.search.toLowerCase(),
            );
        })
        .filter(m => {
          return !this.filter.currentDate
            ? true
            : moment(m.startTime).format("YYYY/MM/DD") ==
                this.filter.currentDate;
        })
        .filter(m => {
          return this.filter.inFuture
            ? true
            : moment(m.actualEndTime || m.endTime).toDate() <=
                moment().utc().toDate();
        })
        .forEach(function (m) {
          output.push({ ...m });
        });
      return output.sort((a, b) => moment(b.startTime) - moment(a.startTime));
    },
    groupedMeeting() {
      return groupBy(
        this.scheduledCallsThatMeetFilterCriteriaAsList,
        function (m) {
          let cc = moment(m.startTime).set({
            minute: 0,
            hour: 0,
            second: 0,
            millisecond: 0,
          });

          return cc;
        },
      );
    },
  },
  components: {
    ScheduledCall,
    ScheduleZoomSenseDialog,
  },
};
</script>

<style scoped>
h1 {
  margin-bottom: 1em;
}

.md-empty-state {
  margin-top: -4em;
}
</style>
